# import unittest
# from unittest import TestCase
#
# import six
# from numpy.testing.utils import assert_array_equal, assert_almost_equal
#
# from quantdsl.domain.services.schwartzsmith_old import calibrate, simulate_prices, plot_simulated_prices
# import json
# import datetime
# import numpy as np
#
# # Todo: Maybe remove this stuff, because it doesn't really fit very well.
#
# class TestSchwartzSmithPriceProcess(TestCase):
#
#     def setUp(self):
#         np.random.seed(1234)
#
#     def _testCalibrateAndSimulateAndPlot(self):
#         allData = self.allObservedData[:]
#         allOptimizedSchwartzParams, allOptimizedSeasonalParams, allRhos, correlationMatrix, simCorrelations, simulatedPrices = calibrate(allData, niter=100, path_count=50000)
#
#         print("allOptimizedSchwartzParams:", repr(allOptimizedSchwartzParams), "allOptimizedSeasonalParams:", repr(allOptimizedSeasonalParams), "allRhos:", repr(allRhos), "correlationMatrix:", repr(correlationMatrix), "simCorrelations:", repr(simCorrelations))
#
#         plot_simulated_prices(allData, simulatedPrices)
#
#     def _testCalibrate(self):
#         allOptimizedParams, allOptimizedSeasonalFactors, allRhos, correlationMatrix, simCorrelations, simulatedPrices = calibrate(self.allObservedData, niter=3)
#         # Assert allOptimizedParams.
#         # print(repr(allRhos))
#         # raise Exception(json.dumps([list(allRhos[i]) for i in range(4)], indent=4))
#         places = 7
#         for i in range(len(self.allOptimizedParams)):
#             for key in allOptimizedParams[i].keys():
#                 actual_param = allOptimizedParams[i][key]
#                 expected_param = self.allOptimizedParams[i][key]
#                 self.assertAlmostEqual(actual_param, expected_param, places=1, msg=(actual_param, expected_param, i,
#                                                                                          key))
#         # Assert allOptimizedSeasonalFactors.
#         for i in range(len(self.allOptimizedSeasonalFactors)):
#             assert_almost_equal(allOptimizedSeasonalFactors[i], self.allOptimizedSeasonalFactors[i])
#             # for j in range(12):
#             #     self.assertAlmostEqual(allOptimizedSeasonalFactors[i][j], self.allOptimizedSeasonalFactors[i][j], places=7, msg=(i, j))
#         # Assert allRhos
#         for i in range(len(self.allOptimizedSeasonalFactors)):
#             assert_almost_equal(allRhos[i], self.allRhos[i], decimal=7, err_msg=repr(allRhos[i]) + repr(self.allRhos[i]))
#
#     def _testSimulate(self):
#         months = self.allObservedData[0]['months']
#         observation_date = self.allObservedData[0]['observation_date']
#
#         simulatedPrices = simulate_prices(observation_date, months, self.allOptimizedParams,
#                                          self.allOptimizedSeasonalFactors, self.allRhos, path_count=100000)
#
#         plot_simulated_prices(self.allObservedData, simulatedPrices)
#
#     @property
#     def allObservedData(self):
#         if not hasattr(self, '_allObservedData'):
#             alldata = json.loads(exampleData)
#             for i, commodity_data in enumerate(alldata):
#                 observation_date = datetime.datetime(*[int(x) for x in commodity_data['observation_date'].split('-')])
#                 commodity_data['observation_date'] = observation_date
#                 months = np.array([datetime.datetime(*[int(x) for x in m.split('-')]) for m in commodity_data['months']])
#                 commodity_data['months'] = months
#                 futures = np.array(commodity_data['futures'])
#                 commodity_data['futures'] = futures
#                 impvols = np.array(commodity_data['impliedAtmVols'])
#                 commodity_data['impliedAtmVols'] = impvols
#                 alldata[i] = commodity_data
#             self._allObservedData = alldata
#         return self._allObservedData
#
#     @property
#     def allOptimizedParams(self):
#         return [
#             {
#                 "lambdax": -0.30808922684874834,
#                 "kappa": 1.2298043401302943,
#                 "sigmax": 0.4051843919603943,
#                 "lambdae": 0.03502181591846007,
#                 "sigmae": 0.14834693227084453,
#                 "pxe": 0.7127271152250868,
#                 "x0": 0.25895177554007903,
#                 "mue": 0.06087641922532129,
#                 "e0": 3.575773806250119
#             },
#             {
#                 "lambdax": -0.013219031302796013,
#                 "kappa": 0.5755104294274808,
#                 "sigmax": 0.3019978421220578,
#                 "lambdae": 0.01962581740040401,
#                 "sigmae": 0.10846086246261541,
#                 "pxe": 0.9994636963164909,
#                 "x0": 0.004684312359889719,
#                 "mue": 0.04008789895673058,
#                 "e0": 3.6645332024970023
#             },
#             {
#                 "lambdax": -0.19010433120606487,
#                 "kappa": 0.22412012043239407,
#                 "sigmax": 0.3543183310494786,
#                 "lambdae": 0.16384324798602015,
#                 "sigmae": 0.0,
#                 "pxe": 0.9469816097439966,
#                 "x0": 0.6258025422436256,
#                 "mue": 0.17176443810597977,
#                 "e0": 2.8201206397304683
#             },
#             {
#                 "lambdax": -0.45172054817866447,
#                 "kappa": 0.6492520682387822,
#                 "sigmax": 0.32263146865242,
#                 "lambdae": 0.13128677308889297,
#                 "sigmae": 0.1817093581046903,
#                 "pxe": 0.24440367248763362,
#                 "x0": 0.5701229932188968,
#                 "mue": 0.15163061709155676,
#                 "e0": 0.9471551891192342
#             }
#         ]
#         # return [
#         #     {'kappa': 1.2638916531154194, 'sigmae': 0.14734516836401912, 'lambdae': 0.027771544884619619, 'mue': 0.053956757418720531, 'lambdax': -0.38068685060909119, 'sigmax': 0.37788634539857169, 'x0': 0.31473878159096852, 'e0': 3.5234145313102969, 'pxe': 0.92411109909993516},
#         #     {'kappa': 0.57715534625392007, 'sigmae': 0.10887723177092901, 'lambdae': -0.019285073785667982, 'mue': 0.0011320459844574805, 'lambdax': -0.61927428333859191, 'sigmax': 0.30200640241924076, 'x0': 1.0545125321082249, 'e0': 2.6147271447074214, 'pxe': 0.99575689314604499},
#         #     {'kappa': 0.22412720578496656, 'sigmae': 0.0, 'lambdae': 0.044745554489620816, 'mue': 0.05264568084973386, 'lambdax': -0.18589203406147856, 'sigmax': 0.35431191721351657, 'x0': 0.60673647390729191, 'e0': 2.8391451263673511, 'pxe': 0.34674867917684954},
#         #     {'kappa': 0.71269338830064555, 'sigmae': 0.18277823295767753, 'lambdae': 0.16091066685389732, 'mue': 0.18183521244793757, 'lambdax': -0.47577330791415523, 'sigmax': 0.31470493509078834, 'x0': 0.54187739996761075, 'e0': 0.97087034742915801, 'pxe': 0.32484063875303243}]
#
#     @property
#     def allOptimizedSeasonalFactors(self):
#         return [
#             np.array([
#                 1.050348996284317,
#                 1.046837395039804,
#                 0.9494202367799216,
#                 0.9375426387323665,
#                 0.9235130065696228,
#                 1.0058393022337757,
#                 1.1881576256442457,
#                 1.1847473735567835,
#                 0.9672503024832304,
#                 0.8904334742826077,
#                 0.8913216061342772,
#                 0.9645880392713432
#             ]),
#             np.array([
#                 1.0767910316837705,
#                 1.073625330805691,
#                 0.9740410470200886,
#                 0.9572788392087623,
#                 0.9500409115201641,
#                 1.0350955818315335,
#                 1.1295034704522076,
#                 1.097294429299283,
#                 0.9259234164365695,
#                 0.8919545775197973,
#                 0.8936103787680786,
#                 0.9948408178291148
#             ]),
#             np.array([
#                 1.236095256194696,
#                 1.233577771889549,
#                 1.0549431482438154,
#                 0.9384458320988062,
#                 0.8520789458207282,
#                 0.8519040577117131,
#                 0.9500807478679023,
#                 0.9831642534932628,
#                 0.9087576001581256,
#                 0.9062795556280672,
#                 0.9734407962479056,
#                 1.1112320306079717
#             ]),
#             np.array([
#                 1.2351495185137715,
#                 1.2012154939815365,
#                 1.0093090390625412,
#                 0.9292702548449803,
#                 0.9180124462950272,
#                 0.916871041202468,
#                 0.9293038176002943,
#                 0.9315249447402449,
#                 0.9176028288469055,
#                 0.9271444621633762,
#                 0.9704613612510679,
#                 1.114134786355642
#             ])
#         ]
#
#     @property
#     def allRhos(self):
#         return np.array(
#               [[ 1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ],
#                [ 0.98062612,  0.98269122,  0.98519932,  0.98757222,  0.99037885,
#                  0.9929752 ,  0.99564873,  0.99872788,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ],
#                [ 0.60733339,  0.60882546,  0.61069238,  0.61249914,  0.61467398,
#                  0.61671392,  0.6188364 ,  0.62130238,  0.62354668,  0.62611161,
#                  0.62841245,  0.63072028,  0.63302414,  0.63559907,  0.63786333,
#                  0.64009673,  0.64256452,  0.64471243,  0.64707187,  0.64911476,
#                  0.65110375,  0.65327468,  0.65514379,  0.65695526,  0.658709  ,
#                  0.66061338,  0.66224604,  0.66382321,  0.66553288,  0.66699684,
#                  0.66858335,  0.66994194,  0.67125399,  0.672677  ,  0.67389706,
#                  0.67507715,  0.67621941,  0.67746187,  0.67853075,  0.67956832,
#                  0.68070067,  0.68167833,  0.68274816,  0.68367443,  0.6845793 ,
#                  0.68557376,  0.68643862,  0.68728709,  0.68812063,  0.68904224,
#                  0.68984858,  0.69064412,  0.69152765,  0.69230407,  0.69316884,
#                  0.69393088,  0.69468764,  0.69553377,  0.69628214,  0.69702779,
#                  0.69786428,  0.69860647,  0.69934804,  0.7001823 ,  0.70092444,
#                  0.70176067,  0.70250568,  0.70325274,  0.70409612,  0.70484884,
#                  0.70569951,  0.70636425,  0.70722326,  0.70799121,  0.70876355,
#                  0.70963796,  0.71042037,  0.71130662,  0.71209994,  0.71289867,
#                  0.71380385,  0.71461447,  0.71553335,  0.71625318],
#                [ 0.65686305,  0.66106406,  0.66594252,  0.67040208,  0.67554337,
#                  0.68021202,  0.68496274,  0.69039325,  0.6952867 ,  0.70085559,
#                  0.70585397,  0.71089062,  0.71595946,  0.72169371,  0.72681394,
#                  0.73195176,  0.73774863,  0.74291324,  0.74873371,  0.75391453,
#                  0.75910043,  0.76493916,  0.77013221,  0.77532743,  0.7805243 ,
#                  0.78637229,  0.79157156,  0.79677162,  0.80262248,  0.80782386,
#                  0.81367601,  0.81887839,  0.82408112,  0.82993451,  0.83513769,
#                  0.84034089,  0.84554395,  0.85139698,  0.85659906,  0.86180031,
#                  0.86765036,  0.87284886,  0.878695  ,  0.88388924,  0.8890809 ,
#                  0.89491793,  0.90010275,  0.90528371,  0.91046035,  0.91627836,
#                  0.92144436,  0.92660465,  0.93240258,  0.93754922,  0.94333066,
#                  0.94846164,  0.95358455,  0.95933764,  0.96444198,  0.96953694,
#                  0.97525704,  0.98033071,  0.98539376,  0.99107653,  0.9961158 ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ,  1.        ,
#                  1.        ,  1.        ,  1.        ,  1.        ]])
#
#
#
# exampleData = """
# [
#     {
#         "name": "5x16",
#         "impliedAtmVols": [
#             0.558348,
#             0.4499949999999999,
#             0.47476599999999997,
#             0.542777,
#             0.542777,
#             0.394565,
#             0.38154699999999997,
#             0.352567,
#             0.352567,
#             0.3349375,
#             0.3349375,
#             0.3317405,
#             0.317308,
#             0.314525,
#             0.312202,
#             0.32533499999999993,
#             0.32533499999999993,
#             0.29711399999999993,
#             0.30157599999999996,
#             0.2908925,
#             0.2888225,
#             0.306935,
#             0.306935,
#             0.270687,
#             0.262706,
#             0.25352899999999995,
#             0.251896,
#             0.294078,
#             0.294078,
#             0.25406949999999995,
#             0.259417,
#             0.23431249999999998,
#             0.228183,
#             0.263764,
#             0.2593135,
#             0.25772649999999997,
#             0.25665699999999997,
#             0.25620849999999995,
#             0.2557715,
#             0.25167749999999994,
#             0.24745699999999998,
#             0.24644499999999997,
#             0.2448695,
#             0.245272,
#             0.24606549999999996,
#             0.24448999999999999,
#             0.2429605,
#             0.2414885,
#             0.2400395,
#             0.238648,
#             0.23729099999999997,
#             0.2359685,
#             0.23469199999999998,
#             0.2334385,
#             0.23221949999999997,
#             0.231035,
#             0.2298735,
#             0.2287465,
#             0.22764249999999997,
#             0.22656149999999997,
#             0.22543449999999998,
#             0.22426149999999997,
#             0.2230425,
#             0.2217775,
#             0.22046649999999998,
#             0.219098,
#             0.2177065,
#             0.21625749999999996,
#             0.214774,
#             0.2132445,
#             0.2116805,
#             0.210082,
#             0.20850649999999998,
#             0.206977,
#             0.205482,
#             0.20401,
#             0.2025725,
#             0.20116949999999997,
#             0.19978949999999998,
#             0.19844399999999998,
#             0.1971215,
#             0.19582199999999997,
#             0.19454549999999998,
#             0.19330349999999996
#         ],
#         "months": [
#             "2011-04-01",
#             "2011-05-01",
#             "2011-06-01",
#             "2011-07-01",
#             "2011-08-01",
#             "2011-09-01",
#             "2011-10-01",
#             "2011-11-01",
#             "2011-12-01",
#             "2012-01-01",
#             "2012-02-01",
#             "2012-03-01",
#             "2012-04-01",
#             "2012-05-01",
#             "2012-06-01",
#             "2012-07-01",
#             "2012-08-01",
#             "2012-09-01",
#             "2012-10-01",
#             "2012-11-01",
#             "2012-12-01",
#             "2013-01-01",
#             "2013-02-01",
#             "2013-03-01",
#             "2013-04-01",
#             "2013-05-01",
#             "2013-06-01",
#             "2013-07-01",
#             "2013-08-01",
#             "2013-09-01",
#             "2013-10-01",
#             "2013-11-01",
#             "2013-12-01",
#             "2014-01-01",
#             "2014-02-01",
#             "2014-03-01",
#             "2014-04-01",
#             "2014-05-01",
#             "2014-06-01",
#             "2014-07-01",
#             "2014-08-01",
#             "2014-09-01",
#             "2014-10-01",
#             "2014-11-01",
#             "2014-12-01",
#             "2015-01-01",
#             "2015-02-01",
#             "2015-03-01",
#             "2015-04-01",
#             "2015-05-01",
#             "2015-06-01",
#             "2015-07-01",
#             "2015-08-01",
#             "2015-09-01",
#             "2015-10-01",
#             "2015-11-01",
#             "2015-12-01",
#             "2016-01-01",
#             "2016-02-01",
#             "2016-03-01",
#             "2016-04-01",
#             "2016-05-01",
#             "2016-06-01",
#             "2016-07-01",
#             "2016-08-01",
#             "2016-09-01",
#             "2016-10-01",
#             "2016-11-01",
#             "2016-12-01",
#             "2017-01-01",
#             "2017-02-01",
#             "2017-03-01",
#             "2017-04-01",
#             "2017-05-01",
#             "2017-06-01",
#             "2017-07-01",
#             "2017-08-01",
#             "2017-09-01",
#             "2017-10-01",
#             "2017-11-01",
#             "2017-12-01",
#             "2018-01-01",
#             "2018-02-01",
#             "2018-03-01"
#         ],
#         "observation_date": "2011-01-21",
#         "futures": [
#             45.0,
#             44.75,
#             48.9,
#             58.0,
#             58.0,
#             47.85,
#             44.3,
#             44.55,
#             48.85,
#             52.6,
#             52.6,
#             48.1,
#             47.0,
#             46.55,
#             50.85,
#             59.9,
#             59.9,
#             49.5,
#             45.85,
#             46.2,
#             50.1,
#             54.7245,
#             54.7245,
#             50.1,
#             48.9567,
#             48.4362,
#             52.9055,
#             62.312,
#             62.312,
#             51.4496,
#             47.4447,
#             47.8085,
#             51.8621,
#             57.8534,
#             57.8534,
#             52.7104,
#             51.5075,
#             50.9599,
#             55.6621,
#             65.5586,
#             65.5586,
#             54.1303,
#             49.9167,
#             50.2995,
#             54.5643,
#             61.2394,
#             61.2394,
#             55.7953,
#             54.522,
#             53.9424,
#             58.9198,
#             69.3956,
#             69.3956,
#             57.2983,
#             52.8382,
#             53.2433,
#             57.7578,
#             64.3649,
#             64.3649,
#             58.643,
#             57.3047,
#             56.6955,
#             61.9269,
#             72.9374,
#             72.9374,
#             60.2227,
#             55.5349,
#             55.9608,
#             60.7056,
#             64.02762447144308,
#             64.02762447144308,
#             58.3357075343679,
#             57.0044202981548,
#             56.39841253883252,
#             61.602399722218294,
#             72.55520411161102,
#             72.55520411161102,
#             59.90712982163221,
#             55.24389414508752,
#             55.66756240624209,
#             60.38749939972927,
#             63.69211628474737,
#             63.69211628474737,
#             58.03002529773899
#         ]
#     },
#     {
#         "name": "2x16",
#         "impliedAtmVols": [
#             0.55276452,
#             0.4454950499999999,
#             0.47001834,
#             0.5373492299999999,
#             0.5373492299999999,
#             0.39061935,
#             0.37773153,
#             0.34904133000000004,
#             0.34904133000000004,
#             0.331588125,
#             0.331588125,
#             0.328423095,
#             0.31413492,
#             0.31137975,
#             0.30907998,
#             0.32208164999999994,
#             0.32208164999999994,
#             0.29414285999999995,
#             0.29856024,
#             0.287983575,
#             0.28593427499999996,
#             0.30386565,
#             0.30386565,
#             0.26798013,
#             0.26007894,
#             0.2509937099999999,
#             0.24937704,
#             0.29113722000000003,
#             0.29113722000000003,
#             0.25152880499999997,
#             0.25682283,
#             0.23196937499999998,
#             0.22590116999999998,
#             0.26112636,
#             0.25672036499999995,
#             0.255149235,
#             0.25409043,
#             0.25364641499999996,
#             0.25321378499999997,
#             0.24916072499999994,
#             0.24498242999999997,
#             0.24398054999999996,
#             0.242420805,
#             0.24281928,
#             0.24360484499999996,
#             0.24204509999999999,
#             0.240530895,
#             0.239073615,
#             0.237639105,
#             0.23626152,
#             0.23491808999999997,
#             0.233608815,
#             0.23234507999999998,
#             0.231104115,
#             0.22989730499999997,
#             0.22872465,
#             0.227574765,
#             0.226459035,
#             0.22536607499999997,
#             0.22429588499999997,
#             0.223180155,
#             0.22201888499999997,
#             0.220812075,
#             0.21955972499999998,
#             0.218261835,
#             0.21690701999999998,
#             0.215529435,
#             0.21409492499999996,
#             0.21262625999999998,
#             0.211112055,
#             0.209563695,
#             0.20798118,
#             0.206421435,
#             0.20490723,
#             0.20342717999999999,
#             0.2019699,
#             0.20054677499999998,
#             0.19915780499999997,
#             0.19779160499999998,
#             0.19645955999999998,
#             0.195150285,
#             0.19386377999999996,
#             0.19260004499999997,
#             0.19137046499999996
#         ],
#         "months": [
#             "2011-04-01",
#             "2011-05-01",
#             "2011-06-01",
#             "2011-07-01",
#             "2011-08-01",
#             "2011-09-01",
#             "2011-10-01",
#             "2011-11-01",
#             "2011-12-01",
#             "2012-01-01",
#             "2012-02-01",
#             "2012-03-01",
#             "2012-04-01",
#             "2012-05-01",
#             "2012-06-01",
#             "2012-07-01",
#             "2012-08-01",
#             "2012-09-01",
#             "2012-10-01",
#             "2012-11-01",
#             "2012-12-01",
#             "2013-01-01",
#             "2013-02-01",
#             "2013-03-01",
#             "2013-04-01",
#             "2013-05-01",
#             "2013-06-01",
#             "2013-07-01",
#             "2013-08-01",
#             "2013-09-01",
#             "2013-10-01",
#             "2013-11-01",
#             "2013-12-01",
#             "2014-01-01",
#             "2014-02-01",
#             "2014-03-01",
#             "2014-04-01",
#             "2014-05-01",
#             "2014-06-01",
#             "2014-07-01",
#             "2014-08-01",
#             "2014-09-01",
#             "2014-10-01",
#             "2014-11-01",
#             "2014-12-01",
#             "2015-01-01",
#             "2015-02-01",
#             "2015-03-01",
#             "2015-04-01",
#             "2015-05-01",
#             "2015-06-01",
#             "2015-07-01",
#             "2015-08-01",
#             "2015-09-01",
#             "2015-10-01",
#             "2015-11-01",
#             "2015-12-01",
#             "2016-01-01",
#             "2016-02-01",
#             "2016-03-01",
#             "2016-04-01",
#             "2016-05-01",
#             "2016-06-01",
#             "2016-07-01",
#             "2016-08-01",
#             "2016-09-01",
#             "2016-10-01",
#             "2016-11-01",
#             "2016-12-01",
#             "2017-01-01",
#             "2017-02-01",
#             "2017-03-01",
#             "2017-04-01",
#             "2017-05-01",
#             "2017-06-01",
#             "2017-07-01",
#             "2017-08-01",
#             "2017-09-01",
#             "2017-10-01",
#             "2017-11-01",
#             "2017-12-01",
#             "2018-01-01",
#             "2018-02-01",
#             "2018-03-01"
#         ],
#         "observation_date": "2011-01-21",
#         "futures": [
#             39.1015,
#             39.15625,
#             42.7875,
#             46.87119,
#             45.65369,
#             38.89996,
#             37.6733,
#             37.9059,
#             42.74375,
#             46.025,
#             46.025,
#             42.0875,
#             40.83934,
#             40.73125,
#             44.49375,
#             48.40662,
#             47.14924,
#             40.24134,
#             38.99144,
#             39.30982,
#             43.8375,
#             47.88394,
#             47.88394,
#             43.8375,
#             42.53956,
#             42.38168,
#             46.29231,
#             50.35582,
#             49.0478,
#             41.82628,
#             40.3476,
#             40.67843,
#             45.37934,
#             50.62173,
#             50.62173,
#             46.1216,
#             44.75601,
#             44.58991,
#             48.70434,
#             52.97947,
#             51.60331,
#             44.00557,
#             42.44982,
#             42.79793,
#             47.74376,
#             53.58448,
#             53.58448,
#             48.82089,
#             47.37538,
#             47.1996,
#             51.55483,
#             56.08024,
#             54.62353,
#             46.58101,
#             44.9343,
#             45.30269,
#             50.53808,
#             56.31929,
#             56.31929,
#             51.31263,
#             49.79333,
#             49.60856,
#             54.18604,
#             58.94246,
#             57.4114,
#             48.95842,
#             47.22761,
#             47.61491,
#             53.1174,
#             54.899192514356194,
#             54.899192514356194,
#             50.0187760319409,
#             48.53778535917032,
#             48.35767435633492,
#             52.81973266265617,
#             57.456218975944815,
#             55.963764832949934,
#             47.72392771248903,
#             46.03676028911113,
#             46.41429447430434,
#             51.77803854526688,
#             53.51490295293749,
#             53.51490295293749,
#             48.7575467430429
#         ]
#     },
#     {
#         "name": "7x8",
#         "impliedAtmVols": [
#             0.55276452,
#             0.4454950499999999,
#             0.47001834,
#             0.5373492299999999,
#             0.5373492299999999,
#             0.39061935,
#             0.37773153,
#             0.34904133000000004,
#             0.34904133000000004,
#             0.331588125,
#             0.331588125,
#             0.328423095,
#             0.31413492,
#             0.31137975,
#             0.30907998,
#             0.32208164999999994,
#             0.32208164999999994,
#             0.29414285999999995,
#             0.29856024,
#             0.287983575,
#             0.28593427499999996,
#             0.30386565,
#             0.30386565,
#             0.26798013,
#             0.26007894,
#             0.2509937099999999,
#             0.24937704,
#             0.29113722000000003,
#             0.29113722000000003,
#             0.25152880499999997,
#             0.25682283,
#             0.23196937499999998,
#             0.22590116999999998,
#             0.26112636,
#             0.25672036499999995,
#             0.255149235,
#             0.25409043,
#             0.25364641499999996,
#             0.25321378499999997,
#             0.24916072499999994,
#             0.24498242999999997,
#             0.24398054999999996,
#             0.242420805,
#             0.24281928,
#             0.24360484499999996,
#             0.24204509999999999,
#             0.240530895,
#             0.239073615,
#             0.237639105,
#             0.23626152,
#             0.23491808999999997,
#             0.233608815,
#             0.23234507999999998,
#             0.231104115,
#             0.22989730499999997,
#             0.22872465,
#             0.227574765,
#             0.226459035,
#             0.22536607499999997,
#             0.22429588499999997,
#             0.223180155,
#             0.22201888499999997,
#             0.220812075,
#             0.21955972499999998,
#             0.218261835,
#             0.21690701999999998,
#             0.215529435,
#             0.21409492499999996,
#             0.21262625999999998,
#             0.211112055,
#             0.209563695,
#             0.20798118,
#             0.206421435,
#             0.20490723,
#             0.20342717999999999,
#             0.2019699,
#             0.20054677499999998,
#             0.19915780499999997,
#             0.19779160499999998,
#             0.19645955999999998,
#             0.195150285,
#             0.19386377999999996,
#             0.19260004499999997,
#             0.19137046499999996
#         ],
#         "months": [
#             "2011-04-01",
#             "2011-05-01",
#             "2011-06-01",
#             "2011-07-01",
#             "2011-08-01",
#             "2011-09-01",
#             "2011-10-01",
#             "2011-11-01",
#             "2011-12-01",
#             "2012-01-01",
#             "2012-02-01",
#             "2012-03-01",
#             "2012-04-01",
#             "2012-05-01",
#             "2012-06-01",
#             "2012-07-01",
#             "2012-08-01",
#             "2012-09-01",
#             "2012-10-01",
#             "2012-11-01",
#             "2012-12-01",
#             "2013-01-01",
#             "2013-02-01",
#             "2013-03-01",
#             "2013-04-01",
#             "2013-05-01",
#             "2013-06-01",
#             "2013-07-01",
#             "2013-08-01",
#             "2013-09-01",
#             "2013-10-01",
#             "2013-11-01",
#             "2013-12-01",
#             "2014-01-01",
#             "2014-02-01",
#             "2014-03-01",
#             "2014-04-01",
#             "2014-05-01",
#             "2014-06-01",
#             "2014-07-01",
#             "2014-08-01",
#             "2014-09-01",
#             "2014-10-01",
#             "2014-11-01",
#             "2014-12-01",
#             "2015-01-01",
#             "2015-02-01",
#             "2015-03-01",
#             "2015-04-01",
#             "2015-05-01",
#             "2015-06-01",
#             "2015-07-01",
#             "2015-08-01",
#             "2015-09-01",
#             "2015-10-01",
#             "2015-11-01",
#             "2015-12-01",
#             "2016-01-01",
#             "2016-02-01",
#             "2016-03-01",
#             "2016-04-01",
#             "2016-05-01",
#             "2016-06-01",
#             "2016-07-01",
#             "2016-08-01",
#             "2016-09-01",
#             "2016-10-01",
#             "2016-11-01",
#             "2016-12-01",
#             "2017-01-01",
#             "2017-02-01",
#             "2017-03-01",
#             "2017-04-01",
#             "2017-05-01",
#             "2017-06-01",
#             "2017-07-01",
#             "2017-08-01",
#             "2017-09-01",
#             "2017-10-01",
#             "2017-11-01",
#             "2017-12-01",
#             "2018-01-01",
#             "2018-02-01",
#             "2018-03-01"
#         ],
#         "observation_date": "2011-01-21",
#         "futures": [
#             31.9791,
#             30.01532,
#             29.69667,
#             30.84948,
#             33.29165,
#             31.46002,
#             31.63013,
#             34.61646,
#             37.40726,
#             43.10484,
#             43.27069,
#             37.20726,
#             32.45639,
#             30.0125,
#             29.38375,
#             32.68444,
#             34.56652,
#             31.58969,
#             32.33345,
#             34.73411,
#             39.75565,
#             45.93463,
#             45.94599,
#             39.17758,
#             34.69984,
#             31.74129,
#             30.61846,
#             35.77007,
#             36.52956,
#             33.94665,
#             34.38436,
#             36.81671,
#             42.49087,
#             49.30485,
#             49.31253,
#             42.24149,
#             37.3779,
#             33.82741,
#             33.76812,
#             38.61936,
#             38.92108,
#             36.9469,
#             37.01295,
#             39.58047,
#             45.86933,
#             52.02408,
#             52.09401,
#             44.78236,
#             39.4835,
#             35.2734,
#             36.3225,
#             41.41102,
#             41.10239,
#             39.02451,
#             38.85214,
#             41.93687,
#             48.45546,
#             55.48635,
#             55.56331,
#             47.9204,
#             41.79232,
#             38.18742,
#             38.79423,
#             42.32447,
#             44.99597,
#             41.66463,
#             41.22851,
#             44.88913,
#             51.62326,
#             54.08725519389445,
#             54.16227463849158,
#             46.71208150821778,
#             40.738521762287455,
#             37.22451973749271,
#             37.81602895235739,
#             41.25725353778596,
#             43.86139135277088,
#             40.61405148057478,
#             40.188928297392586,
#             43.75724533586915,
#             50.321573460153054,
#             52.72343872699253,
#             52.79656654751829,
#             45.534230908556296
#         ]
#     },
#     {
#         "name": "Fuel",
#         "impliedAtmVols": [
#             0.40154549999999994,
#             0.3974975,
#             0.391874,
#             0.387665,
#             0.3925295,
#             0.40544399999999997,
#             0.41543749999999996,
#             0.38081099999999996,
#             0.3521645,
#             0.3401585,
#             0.3453565,
#             0.34562099999999996,
#             0.3135015,
#             0.30423249999999996,
#             0.29464149999999995,
#             0.29277849999999994,
#             0.2949175,
#             0.3055895,
#             0.315445,
#             0.30127699999999996,
#             0.28514249999999997,
#             0.27932349999999995,
#             0.28779899999999997,
#             0.289938,
#             0.2736885,
#             0.27070999999999995,
#             0.2640515,
#             0.2629245,
#             0.2629245,
#             0.270848,
#             0.2798985,
#             0.2708135,
#             0.260843,
#             0.25643849999999996,
#             0.2626715,
#             0.267076,
#             0.256266,
#             0.25667999999999996,
#             0.25210299999999997,
#             0.2496535,
#             0.24797449999999996,
#             0.25828999999999996,
#             0.264339,
#             0.2649255,
#             0.24907849999999998,
#             0.24798599999999998,
#             0.25244799999999995,
#             0.2586235,
#             0.254127,
#             0.2522525,
#             0.2491475,
#             0.2467555,
#             0.2472845,
#             0.2535175,
#             0.2597045,
#             0.2527585,
#             0.24541,
#             0.251436,
#             0.2507805,
#             0.24954999999999997,
#             0.24852649999999998,
#             0.2474915,
#             0.24656,
#             0.24567449999999996,
#             0.24459349999999996,
#             0.24284549999999996,
#             0.2404305,
#             0.23845249999999998,
#             0.236946,
#             0.2353245,
#             0.23363399999999998,
#             0.23186299999999999,
#             0.23012649999999998,
#             0.228436,
#             0.22677999999999995,
#             0.22515849999999998,
#             0.22357149999999998,
#             0.222019,
#             0.22050099999999997,
#             0.2190175,
#             0.21755699999999997,
#             0.2161195,
#             0.21471649999999998,
#             0.21334799999999998
#         ],
#         "months": [
#             "2011-04-01",
#             "2011-05-01",
#             "2011-06-01",
#             "2011-07-01",
#             "2011-08-01",
#             "2011-09-01",
#             "2011-10-01",
#             "2011-11-01",
#             "2011-12-01",
#             "2012-01-01",
#             "2012-02-01",
#             "2012-03-01",
#             "2012-04-01",
#             "2012-05-01",
#             "2012-06-01",
#             "2012-07-01",
#             "2012-08-01",
#             "2012-09-01",
#             "2012-10-01",
#             "2012-11-01",
#             "2012-12-01",
#             "2013-01-01",
#             "2013-02-01",
#             "2013-03-01",
#             "2013-04-01",
#             "2013-05-01",
#             "2013-06-01",
#             "2013-07-01",
#             "2013-08-01",
#             "2013-09-01",
#             "2013-10-01",
#             "2013-11-01",
#             "2013-12-01",
#             "2014-01-01",
#             "2014-02-01",
#             "2014-03-01",
#             "2014-04-01",
#             "2014-05-01",
#             "2014-06-01",
#             "2014-07-01",
#             "2014-08-01",
#             "2014-09-01",
#             "2014-10-01",
#             "2014-11-01",
#             "2014-12-01",
#             "2015-01-01",
#             "2015-02-01",
#             "2015-03-01",
#             "2015-04-01",
#             "2015-05-01",
#             "2015-06-01",
#             "2015-07-01",
#             "2015-08-01",
#             "2015-09-01",
#             "2015-10-01",
#             "2015-11-01",
#             "2015-12-01",
#             "2016-01-01",
#             "2016-02-01",
#             "2016-03-01",
#             "2016-04-01",
#             "2016-05-01",
#             "2016-06-01",
#             "2016-07-01",
#             "2016-08-01",
#             "2016-09-01",
#             "2016-10-01",
#             "2016-11-01",
#             "2016-12-01",
#             "2017-01-01",
#             "2017-02-01",
#             "2017-03-01",
#             "2017-04-01",
#             "2017-05-01",
#             "2017-06-01",
#             "2017-07-01",
#             "2017-08-01",
#             "2017-09-01",
#             "2017-10-01",
#             "2017-11-01",
#             "2017-12-01",
#             "2018-01-01",
#             "2018-02-01",
#             "2018-03-01"
#         ],
#         "observation_date": "2011-01-21",
#         "futures": [
#             4.2928,
#             4.2847,
#             4.352,
#             4.4602,
#             4.5055,
#             4.411,
#             4.4622,
#             4.8135,
#             6.031,
#             6.924,
#             6.7655,
#             5.282,
#             4.89325,
#             4.88025,
#             4.91525,
#             5.02438,
#             5.05725,
#             4.96663,
#             5.0165,
#             5.36865,
#             6.3799,
#             7.2058,
#             7.0345,
#             5.72815,
#             5.275,
#             5.2402,
#             5.2702,
#             5.3746,
#             5.4074,
#             5.3244,
#             5.3842,
#             5.6901,
#             6.6269,
#             7.40525,
#             7.19125,
#             6.0435,
#             5.592,
#             5.5522,
#             5.5772,
#             5.6866,
#             5.7244,
#             5.6364,
#             5.6992,
#             6.0081,
#             6.9449,
#             7.72525,
#             7.51625,
#             6.3685,
#             5.909,
#             5.8662,
#             5.8912,
#             6.0006,
#             6.0464,
#             5.9584,
#             6.0212,
#             6.3231,
#             7.2579,
#             8.03825,
#             7.82925,
#             6.6715,
#             6.207,
#             6.1572,
#             6.1772,
#             6.2816,
#             6.3194,
#             6.2414,
#             6.3162,
#             6.6201,
#             7.5499,
#             8.33525,
#             8.12625,
#             6.9685,
#             6.494,
#             6.4392,
#             6.4642,
#             6.5706,
#             6.6134,
#             6.5354,
#             6.6132,
#             6.9171,
#             7.8469,
#             8.63225,
#             8.41825,
#             7.2605
#         ]
#     }
# ]
# """
#
# # NB: This function was used to extract the data inlined above - it isn't actually needed to run the tests.
# def read_xl_doc():
#     # We want the data in the first columns of the various sheets.
#     alldata = []
#     print_data = []
#     import xlrd
#     with xlrd.open_workbook('SchwartzSmithMultiMarketExampleData.xls') as wb:
#         for sheet_name in wb.sheet_names():
#             sheet = wb.sheet_by_name(sheet_name)
#             month_col_title = sheet.cell_value(1, 0)
#             assert month_col_title == 'Month', month_col_title
#             from xlrd import xldate_as_tuple
#             months = [datetime.datetime(*xldate_as_tuple(c.value, wb.datemode)) for c in sheet.col_slice(0)[2:]]
#
#             fo_col_title = sheet.cell_value(1, 1)
#             assert fo_col_title == 'F0', fo_col_title
#             futures = [c.value for c in sheet.col_slice(1)[2:]]
#
#             iv_col_title = sheet.cell_value(1, 2)
#             assert iv_col_title == "Vol", iv_col_title
#             impvols = [c.value for c in sheet.col_slice(2)[2:]]
#
#             def param(params, key, row, col):
#                 v = sheet.cell_value(row, col)
#                 if isinstance(key, six.string_types) and key.lower()[-4:] == 'date':
#                     v = datetime.datetime(*xldate_as_tuple(v, wb.datemode))
#                 params[key] = v
#
#             observation_date = datetime.datetime(*xldate_as_tuple(sheet.cell_value(21, 15), wb.datemode))
#
#             seasonal_factors = [1] * 12
#             for month_int in range(12):
#                 param(seasonal_factors, month_int, month_int+24, 14)
#
#             params = {}
#             param(params, 'kappa', 18, 13)
#             param(params, 'mue', 18, 14)
#             param(params, 'sigmax', 18, 15)
#             param(params, 'sigmae', 18, 16)
#             param(params, 'lambdae', 18, 17)
#             param(params, 'lambdax', 18, 18)
#             param(params, 'pxe', 18, 19)
#             param(params, 'x0', 18, 20)
#             param(params, 'e0', 18, 21)
#
#             alldata.append([observation_date, months, futures, impvols, seasonal_factors, params])
#             idata = {
#                 'observation_date': "%04d-%02d-%02d" % (observation_date.year, observation_date.month, observation_date.day),
#                 'months': ["%04d-%02d-%02d" % (m.year, m.month, m.day) for m in months],
#                 'futures': [i for i in futures],
#                 'impvols': [i for i in impvols]
#             }
#             print_data.append(idata)
#
#     import json
#     print("import datetime")
#     print("from scipy import array")
#     print()
#     print(json.dumps(print_data, indent=4))
#
#     return alldata
#
# if __name__ == '__main__':
#     unittest.main()
#
#
#
# # Example params in JSON...
# # [
# #     {
# #         "name": "5x16",
# #         "schwartzsmith": {
# #             "lambdax": -0.30808922684874834,
# #             "kappa": 1.2298043401302943,
# #             "sigmax": 0.4051843919603943,
# #             "lambdae": 0.03502181591846007,
# #             "sigmae": 0.14834693227084453,
# #             "pxe": 0.7127271152250868,
# #             "x0": 0.25895177554007903,
# #             "mue": 0.06087641922532129,
# #             "e0": 3.575773806250119
# #         },
# #         "seasonal": [
# #             1.050348996284317,
# #             1.046837395039804,
# #             0.9494202367799216,
# #             0.9375426387323665,
# #             0.9235130065696228,
# #             1.0058393022337757,
# #             1.1881576256442457,
# #             1.1847473735567835,
# #             0.9672503024832304,
# #             0.8904334742826077,
# #             0.8913216061342772,
# #             0.9645880392713432
# #         ],
# #         "rhos": [
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0,
# #             1.0
# #         ]
# #     },
# #     {
# #         "name": "5x2",
# #         "schwartzsmith": {
# #             "lambdax": -0.013219031302796013,
# #             "kappa": 0.5755104294274808,
# #             "sigmax": 0.3019978421220578,
# #             "lambdae": 0.01962581740040401,
# #             "sigmae": 0.10846086246261541,
# #             "pxe": 0.9994636963164909,
# #             "x0": 0.004684312359889719,
# #             "mue": 0.04008789895673058,
# #             "e0": 3.6645332024970023
# #         },
# #         "seasonal": [
# #             1.0767910316837705,
# #             1.073625330805691,
# #             0.9740410470200886,
# #             0.9572788392087623,
# #             0.9500409115201641,
# #             1.0350955818315335,
# #             1.1295034704522076,
# #             1.097294429299283,
# #             0.9259234164365695,
# #             0.8919545775197973,
# #             0.8936103787680786,
# #             0.9948408178291148
# #         ],
# #         "rhos": [
# #             0.98062612,
# #             0.98269122,
# #             0.98519932,
# #             0.98757222,
# #             0.99037885,
# #             0.9929752 ,
# #             0.99564873,
# #             0.99872788,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0
# #         ]
# #     },
# #     {
# #         "name": "7x8",
# #         "schwartzsmith": {
# #             "lambdax": -0.19010433120606487,
# #             "kappa": 0.22412012043239407,
# #             "sigmax": 0.3543183310494786,
# #             "lambdae": 0.16384324798602015,
# #             "sigmae": 0.0,
# #             "pxe": 0.9469816097439966,
# #             "x0": 0.6258025422436256,
# #             "mue": 0.17176443810597977,
# #             "e0": 2.8201206397304683
# #         },
# #         "seasonal": [
# #             1.236095256194696,
# #             1.233577771889549,
# #             1.0549431482438154,
# #             0.9384458320988062,
# #             0.8520789458207282,
# #             0.8519040577117131,
# #             0.9500807478679023,
# #             0.9831642534932628,
# #             0.9087576001581256,
# #             0.9062795556280672,
# #             0.9734407962479056,
# #             1.1112320306079717
# #         ],
# #         "rhos": [
# #             0.60733339,
# #             0.60882546,
# #             0.61069238,
# #             0.61249914,
# #             0.61467398,
# #             0.61671392,
# #             0.6188364 ,
# #             0.62130238,
# #             0.62354668,
# #             0.62611161,
# #             0.62841245,
# #             0.63072028,
# #             0.63302414,
# #             0.63559907,
# #             0.63786333,
# #             0.64009673,
# #             0.64256452,
# #             0.64471243,
# #             0.64707187,
# #             0.64911476,
# #             0.65110375,
# #             0.65327468,
# #             0.65514379,
# #             0.65695526,
# #             0.658709  ,
# #             0.66061338,
# #             0.66224604,
# #             0.66382321,
# #             0.66553288,
# #             0.66699684,
# #             0.66858335,
# #             0.66994194,
# #             0.67125399,
# #             0.672677  ,
# #             0.67389706,
# #             0.67507715,
# #             0.67621941,
# #             0.67746187,
# #             0.67853075,
# #             0.67956832,
# #             0.68070067,
# #             0.68167833,
# #             0.68274816,
# #             0.68367443,
# #             0.6845793 ,
# #             0.68557376,
# #             0.68643862,
# #             0.68728709,
# #             0.68812063,
# #             0.68904224,
# #             0.68984858,
# #             0.69064412,
# #             0.69152765,
# #             0.69230407,
# #             0.69316884,
# #             0.69393088,
# #             0.69468764,
# #             0.69553377,
# #             0.69628214,
# #             0.69702779,
# #             0.69786428,
# #             0.69860647,
# #             0.69934804,
# #             0.7001823 ,
# #             0.70092444,
# #             0.70176067,
# #             0.70250568,
# #             0.70325274,
# #             0.70409612,
# #             0.70484884,
# #             0.70569951,
# #             0.70636425,
# #             0.70722326,
# #             0.70799121,
# #             0.70876355,
# #             0.70963796,
# #             0.71042037,
# #             0.71130662,
# #             0.71209994,
# #             0.71289867,
# #             0.71380385,
# #             0.71461447,
# #             0.71553335,
# #             0.71625318
# #         ]
# #     },
# #     {
# #         "name": "Fuel",
# #         "schwartzsmith": {
# #             "lambdax": -0.45172054817866447,
# #             "kappa": 0.6492520682387822,
# #             "sigmax": 0.32263146865242,
# #             "lambdae": 0.13128677308889297,
# #             "sigmae": 0.1817093581046903,
# #             "pxe": 0.24440367248763362,
# #             "x0": 0.5701229932188968,
# #             "mue": 0.15163061709155676,
# #             "e0": 0.9471551891192342
# #         },
# #         "seasonal": [
# #             1.2351495185137715,
# #             1.2012154939815365,
# #             1.0093090390625412,
# #             0.9292702548449803,
# #             0.9180124462950272,
# #             0.916871041202468,
# #             0.9293038176002943,
# #             0.9315249447402449,
# #             0.9176028288469055,
# #             0.9271444621633762,
# #             0.9704613612510679,
# #             1.114134786355642
# #         ],
# #         "rhos": [
# #             0.65686305,
# #             0.66106406,
# #             0.66594252,
# #             0.67040208,
# #             0.67554337,
# #             0.68021202,
# #             0.68496274,
# #             0.69039325,
# #             0.6952867 ,
# #             0.70085559,
# #             0.70585397,
# #             0.71089062,
# #             0.71595946,
# #             0.72169371,
# #             0.72681394,
# #             0.73195176,
# #             0.73774863,
# #             0.74291324,
# #             0.74873371,
# #             0.75391453,
# #             0.75910043,
# #             0.76493916,
# #             0.77013221,
# #             0.77532743,
# #             0.7805243 ,
# #             0.78637229,
# #             0.79157156,
# #             0.79677162,
# #             0.80262248,
# #             0.80782386,
# #             0.81367601,
# #             0.81887839,
# #             0.82408112,
# #             0.82993451,
# #             0.83513769,
# #             0.84034089,
# #             0.84554395,
# #             0.85139698,
# #             0.85659906,
# #             0.86180031,
# #             0.86765036,
# #             0.87284886,
# #             0.878695  ,
# #             0.88388924,
# #             0.8890809 ,
# #             0.89491793,
# #             0.90010275,
# #             0.90528371,
# #             0.91046035,
# #             0.91627836,
# #             0.92144436,
# #             0.92660465,
# #             0.93240258,
# #             0.93754922,
# #             0.94333066,
# #             0.94846164,
# #             0.95358455,
# #             0.95933764,
# #             0.96444198,
# #             0.96953694,
# #             0.97525704,
# #             0.98033071,
# #             0.98539376,
# #             0.99107653,
# #             0.9961158 ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0       ,
# #             1.0
# #         ]
# #     }
# # ]
